<?php

function trouve_table($table, $tableau_tables)
{
	$trouve = false;
	for ($i=0; $i<count($tableau_tables); $i++)
	{
		if (strstr($table, $tableau_tables[$i])) {$trouve = true; break;}
	}
	return $trouve;
}


//fonction originale mail_attachement en utilisation libre
//Auteur : Damien Seguy
//Url : http://www.nexen.net
//modifie pour plus de souplesse sur les enttes
function mail_attachement($to , $sujet , $message , $fichier, $nom, $reply="", $from="")
{
   $limite = "_parties_".md5(uniqid (rand()));
   
   $mail_mime = "Date: ".date("l j F Y, G:i")."\n";
   $mail_mime .= "MIME-Version: 1.0\n";
   $mail_mime .= "Content-Type: multipart/mixed;\n";
   $mail_mime .= " boundary=\"----=$limite\"\n\n";
   
   //Le message en texte simple pour les navigateurs qui n'acceptent pas le HTML
   $texte = "This is a multi-part message in MIME format.\n";
   $texte .= "Ceci est un message est au format MIME.\n";
   $texte .= "------=$limite\n";
   $texte .= "Content-Type: text/plain; charset=\"iso-8859-1\"\n";
   $texte .= "Content-Transfer-Encoding: 32bit\n\n";
   $texte .= $message;
   $texte .= "\n\n";
   
   //le fichier
   $attachement = "------=$limite\n";
   $attachement .= "Content-Type: application/octet-stream; name=\"$nom\"\n";
   $attachement .= "Content-Transfer-Encoding: base64\n";
   $attachement .= "Content-Disposition: attachment; filename=\"$nom\"\n\n";
   
   $fp = fopen($fichier, "rb");
   $buff = fread($fp, filesize($fichier));
   
   fclose($fp);
   $attachement .= chunk_split(base64_encode($buff));
   
   $attachement .= "\n\n\n------=$limite\n";
   
   //formatage des enttes
   if (! empty($reply)) $entete = "Reply-to: $reply\n";
   if (! empty($from)) $entete .= "From: $from\n";
   
   return mail($to, $sujet, $texte.$attachement, $entete.$mail_mime);
}


//crit dans un fichier (compress ou pas)
function ecrire ($texte)
{
   global $fp, $_fputs;
   $_fputs($fp, "$texte\n");
}


function mysql_version()
{
   $result = mysql_query('SELECT VERSION() AS version');
   if ($result != FALSE && @mysql_num_rows($result) > 0)
   {
      $row = mysql_fetch_array($result);
      $match = explode('.', $row['version']);
   }
   else
   {
      $result = @mysql_query('SHOW VARIABLES LIKE \'version\'');
      if ($result != FALSE && @mysql_num_rows($result) > 0)
      {
         $row = mysql_fetch_row($result);
         $match = explode('.', $row[1]);
      }
   }
   
   if (!isset($match) || !isset($match[0])) $match[0] = 3;
   if (!isset($match[1])) $match[1] = 21;
   if (!isset($match[2])) $match[2] = 0;
   return $match[0] . "." . $match[1] . "." . $match[2];
}


include ("export_base_conf.php");
$sauver_base = false;
$fin_sauvegarde_base = false;

//accs admin ou accs rdacteur (si autoris)
if (($connect_statut == "0minirezo") || ($acces_redac && $connect_statut == "1comite"))
{
   //si la compression est impossible, au cas o le webmaster l'aurait activ : on dsactive
   if (!$flag_gz) $gz = false;
   $temps = time();
   
   //1-FAUT IL SAUVER (le soldat ryan ?)
   
   // Lister des fichiers contenus dans le rpertoire de sauvegardes
   $entree = array();
   $nbr_entree = 0;
   $myDirectory = @opendir($rep_bases);
   if ($connect_statut == "0minirezo" && (! $myDirectory)) echo("le rpertoire $rep_bases n'existe pas, corrigez dans le fichier d'options !<br>");
   
   if ($myDirectory)
   {
      while($entryName = readdir($myDirectory))
      {
         //filtre uniquement les fichiers du type : save_nom_de_la_base
         if (substr($entryName, 0, strlen($prefixe_save . $base)) == $prefixe_save . $base)
         {
            $date_fichier = filemtime($rep_bases . $entryName);
            if ($jours_obso > 0 && $temps > ($date_fichier + $jours_obso*3600*24)) @unlink($rep_bases . $entryName);
            else
            {
               $entree[] = $entryName;
               $nbr_entree++;
            }
         }
      }
      closedir($myDirectory);
      //trie dans l'ordre dcroissant les sauvegardes pour mettre la plus rcente en index 0
      rsort($entree);
      
      if ($nbr_entree > 0)
      {
         //rcupre la date de la sauvegarde la plus rcente
         $derniere_maj = filemtime($rep_bases . $entree[0]);
         if ($temps > ($frequence_maj*24*3600+$derniere_maj)) $sauver_base = true;
      }
      else $sauver_base = true;//aucune sauvegarde trouve !!!
         
      //2-ON SAUVE (willy)
      if ($sauver_base)
      {
	  //echo "on sauve la base<br>";
         //calcul de la date
         $jour = date("j", $temps); //format numerique : 1->31
         $annee = date("Y", $temps); //format numerique : 4 chiffres
         $mois = date("m", $temps);
         $heure = date("H", $temps);
         $minutes = date("i", $temps);
         
         //choix du nom
         if ($gz) $suffixe = ".gz";
         else $suffixe = ".sql";
         $nom_fichier = $prefixe_save . $base . "_" . $jour. "_" . $mois. "_" . $annee . $suffixe;
         $chemin_fichier = $rep_bases . $nom_fichier;
         
         //rcupre et spare tous les noms de tables dont on doit viter de rcuprer les donnes
         if (! empty($eviter)) $tab_eviter = explode(";", $eviter);
         if (! empty($accepter)) $tab_accepter = explode(";", $accepter);
         
         // listing des tables
         $res = @mysql_list_tables($base);
         if ($connect_statut == "0minirezo" && (! $res)) echo("impossible de lister les tables de la base $base, corrigez dans le fichier d'options le nom de votre base<br>");
         
         if ($res)
         {
            $num_rows = mysql_num_rows($res);
            $i = 0;
            
            //cration du fichier
            if ($gz) $fp = @gzopen($chemin_fichier, "wb");
            else $fp = @fopen($chemin_fichier, "wb");
            if ($connect_statut == "0minirezo" && (! $fp)) echo ("impossible de crer $nom_fichier, vrifiez les droits d'criture du rpertoire $rep_bases<br>");
            
            if ($fp)
            {
               //slection du type d'criture
               $_fputs = ($gz) ? gzputs : fputs;
               
               //ecriture entete du fichier : infos serveurs php/sql/http
               ecrire("# All your base are belong to silicium :-p");
               ecrire("# Ce script est dispo sur SpipOJapanim (http://spip.japanim.net)");
               ecrire("# Base : $base");
               ecrire("# Serveur : $SERVER_NAME");
               ecrire("# Date : $jour/$mois/$annee  $heure" . "h" . $minutes);
               if (defined('PHP_OS') && eregi('win', PHP_OS)) $os_serveur = "Windows"; else $os_serveur = "Linux/Unix";
               ecrire("# OS Serveur : $os_serveur");
               ecrire("# Version PHP : " . phpversion());
               ecrire("# Version mySQL : " . mysql_version());
               ecrire("# IP Client : $REMOTE_ADDR");
               ecrire("# Fichier SQL 100% compatible PHPMyadmin\n");
               ecrire("# -------debut du fichier----------");
               
               while ($i < $num_rows)
               {
                  $tablename = mysql_tablename($res, $i);

                  //slectionne la table avec nom qui ne correspond pas  $accepter
                     if (empty($accepter) | trouve_table($tablename, $tab_accepter))
                     {
                     
                     //sauve la structure
                     if ($structure)
                     {
                        ecrire("\n# Structure de la table $tablename");
                        ecrire("DROP TABLE IF EXISTS `$tablename`;\n");
                        // requete de creation de la table
                        $query = "SHOW CREATE TABLE $tablename";
                        $resCreate = mysql_query($query);
                        $row = mysql_fetch_array($resCreate);
                        $schema = $row[1].";";
                        ecrire("$schema\n");
                     }
                     
                     //slectionne la table avec nom qui ne correspond pas  $eviter
                     if (empty($eviter) | ! (trouve_table($tablename, $tab_eviter)))
                     {
                        if ($donnees)
                        {
                           // les donnes de la table
                           ecrire("# Donnes de $tablename");
                           $query = "SELECT * FROM $tablename";
                           $resData = @mysql_query($query);
                           //peut survenir avec la corruption d'une table, on prvient
                           if ($connect_statut == "0minirezo" && (!$resData)) echo "problme avec les donnes de $tablename, corruption possible !<br>";
                           else
                           {
                              if (@mysql_num_rows($resData) > 0)
                              {
                                 $sFieldnames = "";
                                 if ($insertComplet)
                                 {
                                    $num_fields = mysql_num_fields($resData);
                                    for($j=0; $j < $num_fields; $j++)
                                    {
                                       $sFieldnames .= "`".mysql_field_name($resData, $j) ."`";
                                       //on ajoute  la fin une virgule si ncessaire
                                       if ($j<$num_fields-1) $sFieldnames .= ", ";
                                    }
                                    $sFieldnames = "($sFieldnames)";
                                 }
                                 $sInsert = "INSERT INTO `$tablename` $sFieldnames values ";
                                 
                                 
                                 while($rowdata = mysql_fetch_row($resData))
                                 {
                                    $lesDonnees = "";
                                    for ($mp = 0; $mp < $num_fields; $mp++)
                                    {
                                       $lesDonnees .= "'" . addslashes($rowdata[$mp]) . "'";
                                       //on ajoute  la fin une virgule si ncessaire
                                       if ($mp<$num_fields-1) $lesDonnees .= ", ";
                                    }
                                    $lesDonnees = "$sInsert($lesDonnees);";
                                    ecrire("$lesDonnees");
                                 }
                              }
                           }
                        }
                     }
                     
                  }
				$i++;
               }
               ecrire("# -------fin du fichier------------");
               
               //on ferme !
               if ($gz) gzclose($fp);
               else fclose($fp);
               
               //envoi par mail
               if (! empty($destinataire_save))
               {
                  $msg_mail = "Sauvegarde de la base effectue avec succs.\n\rBase : $base\n\rServeur : $SERVER_NAME\n\rDate : $jour/$mois/$annee  $heure" . "h" . $minutes;
                  $sujet_mail = "Sauvegarde de la base $base du $jour/$mois/$annee";
                  //msg d'erreur que pour les admins
                  if ($connect_statut == "0minirezo" && (! mail_attachement($destinataire_save, $sujet_mail, $msg_mail, $chemin_fichier, $nom_fichier))) echo "problme d'envoi de $nom_fichier  $destinataire_save<br>";
               }
               
               //marqueur de bon droulement du processus
               $fin_sauvegarde_base = true;
            }
         }
      }
   }
}

?>