<?php 
include ("inc.php3");
debut_page("Configuration de la sauvegarde automatise");
echo "<br><br><br>";
gros_titre("Rglages de la sauvegarde automatise");
debut_gauche();
debut_boite_info();
$page_save_conf = "export_base_conf.php";

echo "<FONT FACE='Verdana,Arial,Helvetica,sans-serif' SIZE=2>";
echo "<P align=left>".propre("Cette page vous permet de consulter les options de sauvegarde de la base. Pour les modifier, veuillez diter le fichier texte $page_save_conf. Auteur : <a href=\"mailto:silicium@japanim.net\">silicium@japanim.net</a>, webmaster de <a href=\"http://www.japanim.net\">Japanim.net</a>.");
echo "</FONT>";

fin_boite_info();
debut_droite();

echo "<FONT SIZE=2 FACE='Georgia,Garamond,Times,serif'>";

if ($connect_statut == "0minirezo")
{
   include("export_base_conf.php");
   echo "<b>Vous avez dfini les rglages suivants :</b><ul>";
   
   echo "<li>Demande de compression GZ ?";
   if ($gz) echo " oui"; else echo " non";
   if (!$flag_gz && $gz) echo "<br><font color=red><b>Attention:</b> la sauvegarde ne pourra pas tre compresse car cette fonctionnalit n'est pas disponible sur votre serveur.</font>";
   echo "</li>";
   
   echo "<li>Tables acceptes : ";
   if (empty($entete)) echo " toutes"; else echo " celles qui ont $entete comme entte de nom";
   echo "</li>";
   
   echo "<li>Donnes ignores :";
   if (empty($eviter)) echo " aucune";
   else
   {
      //rcupre et spare tous les noms de tables dont on vite de rcuprer les donnes
      $tab_eviter = explode(";", $eviter);
      echo " pour les tables avec ";
      for ($ij=0; $ij<count($tab_eviter); $ij++) echo $tab_eviter[$ij] . " ";
      echo " dans le nom";
   }
   echo "</li>";
   
   echo "<li>Rpertoire de stockage : $rep_bases </li>";
   
   echo "<li>Frquence de la sauvegarde : tous les $frequence_maj jours</li>";
   
   echo "<li>Affiche un message de succs lorsque la sauvegarde russit ?";
   if ($ecrire_succes) echo " oui"; else echo " non";
   echo "</li>";
   
   echo "<li>Nom de votre base : $base</li>\n";
   
   if ($jours_obso > -1) echo "<li>Sauvegardes considres obsoltes au bout de $jours_obso jours.</li>";
   
   echo "<li>Sauvegardes envoyes par mail : ";
   if (empty($destinataire_save)) echo "non";
   else echo "oui  l'adresse $destinataire_save";
   echo "</li>";
   
   echo "</ul>";
   echo "<br><b>Sauvegardes effectues :</b><ul>";
   
   // Lister des fichiers contenus
   $entree = array();
   $myDirectory = opendir($rep_bases);
   while($entryName = readdir($myDirectory))
   {
      //uniquement les fichiers du type : prefixe_nom_de_la_base
      if (substr($entryName, 0, strlen($prefixe_save . $base)) == $prefixe_save . $base) $entree[] = $entryName;
   }
   closedir($myDirectory);
   //trie dans l'ordre dcroissant les sauvegardes
   rsort($entree);
   
   for ($i=0; $i<count($entree); $i++) {
      echo "<li>$entree[$i] | ";
      $temps = filemtime($rep_bases . $entree[$i]);
      $jour = date("j", $temps); //format numerique : 1->31
      $annee = date("Y", $temps); //format numerique : 4 chiffres
      $mois = date("m", $temps);
      $heure = date("H", $temps);
      $minutes = date("i", $temps);
      $date = "$jour/$mois/$annee  $heure" . "h" . $minutes;
      echo $date . " | " . taille_en_octets(filesize($rep_bases . $entree[$i])) . "</li>\n";
   }
   echo "</ul>";
}
else echo "<B>Vous n'avez pas acc&egrave;s &agrave; cette page.</B>";
echo "</FONT>";

fin_page();
?>
